#include "window.h"

#include <stdlib.h>

#include "gl.h"

void _tick();
struct sw_window *_tick_window;
void (*_tick_fn)();

struct sw_window *sw_window_create(struct sw_vec2i size, char *title) {
	struct sw_window *win;

	win = malloc(sizeof(struct sw_window));
	win->size = size;

	glfwInit();
	glfwDefaultWindowHints();

	win->_window = glfwCreateWindow(size.x, size.y, title, 0, 0);
	glfwShowWindow(win->_window);
	glfwMakeContextCurrent(win->_window);
	glewInit();
	glfwSwapInterval(1);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glEnable(GL_DEPTH_TEST);

	glClearColor(0.1f, 0.2f, 0.3f, 1.f);
	return win;
}

void sw_window_run(struct sw_window *window, void (*callback)()) {
	_tick_window = window;
	_tick_fn = callback;
#ifdef __EMSCRIPTEN__
	emscripten_set_main_loop(_tick, 60, 1);
#else
	while(!glfwWindowShouldClose(window->_window)) {
		_tick();
	}
#endif
}

/* private functions */

void _tick() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	_tick_fn();
	glfwSwapBuffers(_tick_window->_window);
	glfwPollEvents();
}
